Blockchain API
abci_info - Get application description information
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc: JSONRPC Version, fixed as "2.0"
- id: ID number of API request
- result: Result object
- response: Response result
- data: Application information
- last_block_height: Highest block
- ast_block_app_hash: Last block application hash
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/abci_info'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"response": {
"data": "hashrs",
"last_block_height": "66330",
"last_block_app_hash": "JUNh9eaNklhKgw/vOmia47XMrhBmNNS3K0rKoOgvY1I="
}
}
}
block - Get the data of the specified block
parameter
height - The height of the block to be queried, int64, optional, default value: 0, which means the latest block
return value
Return a JSON object, the structure is as follows:
- block_hash: Block hash
- block: Block information
- header: Block header
- version: Block version
- block: The version number of the block
- app: app version number
- chain_id: ID number of the chain
- height: Block height
- round_received: Receive round
- last_block_id: Previous block
- hash: Block hash
- timestamp: time
- validators_hash: Validator hash
- next_validators_hash: Next validator hash
- consensus_hash: Consensus hash
- last_results_hash: The result of the previous hash
- frame_hash: Hash in consensus state
- txs_hash: txs hash
- app_hash: app hash
- receipts_hash: Receiver's hash
- txs: Transaction set
- receipts:Recipient
- validator: Verifier
- event_cnt: number of events
- tx_cnt: tx number
- signatures: Signature information
- validator: Verifier
- sig: Signature information
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/block?height=10'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"block_hash": "0AE7265F03261DE0954319CE26EBEE26861E4C77B822D4DECD41F8072316764C",
"block": {
"header": {
"version": {
"block": "0",
"app": "0"
},
"chain_id": "8888",
"height": "10",
"round_received": "10",
"last_block_id": {
"hash": "BB88DE30A748AB3078A991EC77B8E3A35375DD953C9C908E4438D98ECDAD02D4"
},
"timestamp": "2020-12-08T03:32:49.099663Z",
"validators_hash": "CA2A8986346FE3916C7990AEF0D5EF17D71B05CB6EACD99CA04D181E27B53B34",
"next_validators_hash": "8B3F76A7073DE568B8A29D5BE6651E0BDFC353DBFE45D6004221E4678CA23842",
"consensus_hash": "FE28D47CACD2C1933202E7921AA39830FE1FF73553AF679104FA60D921D5ABC1",
"last_results_hash": "",
"frame_hash": "B0F72FC119EB9EF7E7BD6A0B82AF5FE27B24BEA27FFD9D172E6F6DBC20FC84F6",
"txs_hash": "",
"app_hash": "5C2C3C2680A11FE0DA551E0D64FD0D9FF3578D244E228452F2EACECFB1FF2021",
"receipts_hash": "AD59A91DC7A762D4D7567AFC504FF69842AB4CF33ABAB4157ACED758A43A2A7C"
},
"txs": null,
"receipts": [
{
"validator": "D8A61174203A4F0E8C7261D5CB0F2419CC95897EBE75022682D518A7E6666D51996ADFFA96",
"event_cnt": "1",
"tx_cnt": "0"
}
],
"signatures": [
{
"validator": "D8A61174203A4F0E8C7261D5CB0F2419CC95897EBE75022682D518A7E6666D51996ADFFA96",
"sig": "4AC43BFC63B7FB740C414BF40A20ABF48584A959FCF7196D189D030CD6E5503DE6D4C80A95117FAA8B971BE675EACCEC5AEDEA7CB0DAECF89CC05EA55F77390E"
}
]
}
}
}
block_results - Get the ABCI result of the specified block
parameter
height - The height of the block to be queried, int64, optional, default value: 0, which means the latest block
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- error:Error description information
- result:Application information results
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/block_results?height=10'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"height": "10",
"txs_results": null,
"begin_block_events": [
{
"type": "transfer",
"attributes": [
{
"key": "cmVjaXBpZW50",
"value": "aGFzaHJzMTd4cGZ2YWttMmFtZzk2MnlsczZmODR6M2tlbGw4YzVsYTI0cHhl"
},
{
"key": "YW1vdW50",
"value": "NDIxODcwMDAzMjIxOTE4NzcwaGNvaW4="
}
]
},
{
"type": "message",
"attributes": [
{
"key": "c2VuZGVy",
"value": "aGFzaHJzMW0zaDMwd2x2c2Y4bGxydXh0cHVrZHZzeTBrbTJrdW04OXozZTJ5"
}
]
},
{
"type": "mint",
"attributes": [
{
"key": "Ym9uZGVkX3JhdGlv",
"value": "MC4wMDAwMDAwMDAwMDAwMDAwMDA="
},
{
"key": "aW5mbGF0aW9u",
"value": "MC4xMzAwMDAyMDU5NzI1NzA3OTA="
},
{
"key": "YW5udWFsX3Byb3Zpc2lvbnM=",
"value": "MTMwMDAwMjEzMDA1MjUwNzQyMzE2NTEwNTAuNDEwNDg5OTYyNjg5NTkyODEw"
},
{
"key": "YW1vdW50",
"value": "NDIxODcwMDAzMjIxOTE4Nzcw"
}
]
},
{
"type": "transfer",
"attributes": [
{
"key": "cmVjaXBpZW50",
"value": "aGFzaHJzMWp2NjVzM2dycWY2djZqbDNkcDR0NmM5dDlyazk5Y2Q4MnZqYXlt"
},
{
"key": "YW1vdW50",
"value": "NDIxODcwMDAzMjIxOTE4NzcwaGNvaW4="
}
]
},
{
"type": "message",
"attributes": [
{
"key": "c2VuZGVy",
"value": "aGFzaHJzMTd4cGZ2YWttMmFtZzk2MnlsczZmODR6M2tlbGw4YzVsYTI0cHhl"
}
]
},
{
"type": "commission",
"attributes": [
{
"key": "YW1vdW50",
"value": "NDIxODcwMDAzMjIxOTE4NzcuMDAwMDAwMDAwMDAwMDAwMDAwaGNvaW4="
},
{
"key": "dmFsaWRhdG9y",
"value": "aGFzaHJzdmFsb3BlcjE3Yzl5dzloZDQwd3BnN3dma2Z0em56ZGZlZ2d4cWM3NnhmMnVrdA=="
}
]
},
{
"type": "rewards",
"attributes": [
{
"key": "YW1vdW50",
"value": "NDIxODcwMDAzMjIxOTE4NzcwLjAwMDAwMDAwMDAwMDAwMDAwMGhjb2lu"
},
{
"key": "dmFsaWRhdG9y",
"value": "aGFzaHJzdmFsb3BlcjE3Yzl5dzloZDQwd3BnN3dma2Z0em56ZGZlZ2d4cWM3NnhmMnVrdA=="
}
]
}
],
"end_block_events": null,
"validator_updates": null,
"consensus_param_updates": null
}
}
blockchain - Query blockchain information
parameter
minHeight - Starting block height maxHeight - Cutoff block height
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- error:Error description information
- result:Application information results
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/blockchain?minHeight=10&maxHeight=10'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"last_height": "67420",
"block_metas": [
{
"block_id": {
"hash": "0AE7265F03261DE0954319CE26EBEE26861E4C77B822D4DECD41F8072316764C"
},
"block_size": "309",
"header": {
"version": {
"block": "0",
"app": "0"
},
"chain_id": "8888",
"height": "10",
"round_received": "10",
"last_block_id": {
"hash": "BB88DE30A748AB3078A991EC77B8E3A35375DD953C9C908E4438D98ECDAD02D4"
},
"timestamp": "2020-12-08T03:32:49.099663Z",
"validators_hash": "CA2A8986346FE3916C7990AEF0D5EF17D71B05CB6EACD99CA04D181E27B53B34",
"next_validators_hash": "8B3F76A7073DE568B8A29D5BE6651E0BDFC353DBFE45D6004221E4678CA23842",
"consensus_hash": "FE28D47CACD2C1933202E7921AA39830FE1FF73553AF679104FA60D921D5ABC1",
"last_results_hash": "",
"frame_hash": "B0F72FC119EB9EF7E7BD6A0B82AF5FE27B24BEA27FFD9D172E6F6DBC20FC84F6",
"txs_hash": "",
"app_hash": "5C2C3C2680A11FE0DA551E0D64FD0D9FF3578D244E228452F2EACECFB1FF2021",
"receipts_hash": "AD59A91DC7A762D4D7567AFC504FF69842AB4CF33ABAB4157ACED758A43A2A7C"
},
"num_txs": "0"
}
]
}
}
commit - Query submission data
TODO
consensus_params - Get consensus parameters
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result: Result object
- block_height: Block height
- consensus_params: Consensus parameters
- event: event max_bytes: Event size time_iota_ms: Minimum time unit
- validator: Verifier pub_key_types: Digital signature algorithm for verifier's public key
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/consensus_params'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"block_height": "67615",
"consensus_params": {
"event": {
"max_gas": "-1",
"max_bytes": "131072",
"time_iota_ms": "1000"
},
"validator": {
"pub_key_types": [
"ed25519"
]
}
}
}
}
consensus_state - Query consensus status
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result: Result Height
- round_state:
- height: Block height
- priv_validator: Verifier private key
- validators_set: Validator set
- validators: List of validators
- address: Verifier address
- pub_key: Verifier public key type: Digital signature algorithm for verifier's public key value: Public key
- voting_power: Voting rights
- proposer_priority: Applicant's priority
- proposer: Proposer
- address: Proposer address
- pub_key: Proposer public key type: Digital signature algorithm of proponent's public key value: Public key
- voting_power: Voting rights
- proposer_priority: Applicant's priority
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/consensus_state'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"round_state": {
"height": "67836",
"priv_validator": "D8A61174203A4F0E8C7261D5CB0F2419CC95897EBE75022682D518A7E6666D51996ADFFA96",
"validators_set": {
"validators": [
{
"address": "B5D2CB1CB0B16BB4710EB322CD124CD6E3F558BB",
"pub_key": {
"type": "hashrs/PubKeyEd25519",
"value": "Ok8OjHJh1csPJBnMlYl+vnUCJoLVGKfmZm1RmWrf+pY="
},
"voting_power": "1",
"proposer_priority": "0"
}
],
"proposer": {
"address": "B5D2CB1CB0B16BB4710EB322CD124CD6E3F558BB",
"pub_key": {
"type": "hashrs/PubKeyEd25519",
"value": "Ok8OjHJh1csPJBnMlYl+vnUCJoLVGKfmZm1RmWrf+pY="
},
"voting_power": "1",
"proposer_priority": "0"
}
}
}
}
}
genesis - Get Genesis Document
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result: result
- genesis: Founding Information
- genesis_time: time
- chain_id: Chain ID number
- consensus_params: Consensus parameters
- event: event information max_gas: How much gas can an event put in, currently this number is sent from the application side. max_bytes: The size of an event is 128m time_iota_ms: The block interval is 1s, currently configured in config.toml
- validator: Verifier pub_key_types: Verifier signature algorithm ed25519
- app_hash:app's hash code
- app_state: App status information gov: Community information mint: Inflation information crisis: Fixed rate information staking: Configuration information of the staking module bank: Configuration information of bank module slashing: Configuration information of the slashing module supply: Configuration information of the supply module params: Parameter information auth: Authentication information punishment: Penalize nodes that do not produce blocks distribution: Distribute block rewards iam: Configuration information of iam module genutil: Generating transaction information for the genesis block
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/genesis'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"genesis": {
"genesis_time": "2020-12-08T03:32:38.144142Z",
"chain_id": "8888",
"consensus_params": {
"event": {
"max_gas": "-1",
"max_bytes": "131072",
"time_iota_ms": "1000"
},
"validator": {
"pub_key_types": [
"ed25519"
]
}
},
"app_hash": "",
"app_state": {
"gov": {
"starting_proposal_id": "1",
"deposits": null,
"votes": null,
"proposals": null,
"deposit_params": {
"min_deposit": [
{
"denom": "hcoin",
"amount": "10000000"
}
],
"max_deposit_period": "172800000000000"
},
"voting_params": {
"voting_period": "172800000000000"
},
"tally_params": {
"quorum": "0.334000000000000000",
"threshold": "0.500000000000000000",
"veto": "0.334000000000000000"
}
},
"mint": {
"minter": {
"latest_block_time": "0001-01-01T00:00:00Z",
"inflation": "0.130000000000000000",
"annual_provisions": "0.000000000000000000"
},
"params": {
"mint_denom": "hcoin",
"inflation_rate_change": "0.130000000000000000",
"inflation_max": "0.200000000000000000",
"inflation_min": "0.070000000000000000",
"goal_bonded": "0.670000000000000000",
"blocks_per_year": "6311520"
}
},
"crisis": {
"constant_fee": {
"denom": "hcoin",
"amount": "1000"
}
},
"staking": {
"params": {
"unbonding_time": "1814400000000000",
"max_validators": 100,
"max_entries": 7,
"historical_entries": 0,
"bond_denom": "hcoin"
},
"last_total_power": "0",
"last_validator_powers": null,
"validators": null,
"delegations": null,
"unbonding_delegations": null,
"redelegations": null,
"exported": false
},
"bank": {
"send_enabled": true
},
"slashing": {
"params": {
"signed_blocks_window": "100",
"min_signed_per_window": "0.500000000000000000",
"downtime_jail_duration": "600000000000",
"slash_fraction_double_sign": "0.050000000000000000",
"slash_fraction_downtime": "0.010000000000000000"
},
"signing_infos": {},
"missed_blocks": {}
},
"supply": {
"supply": []
},
"params": null,
"auth": {
"params": {
"max_memo_characters": "256",
"tx_sig_limit": "7",
"tx_size_cost_per_byte": "10",
"sig_verify_cost_ed25519": "590",
"sig_verify_cost_secp256k1": "1000"
},
"accounts": [
{
"type": "hashrs/MainAccount",
"value": {
"name": "",
"address": "hashrs17c9yw9hd40wpg7wfkftznzdfeggxqc762ueavn",
"sub_addresses": null,
"coins": [
{
"denom": "coin0",
"amount": "1000000000000000000"
},
{
"denom": "coin1",
"amount": "1000000000000000000"
},
{
"denom": "coin2",
"amount": "1000000000000000000"
},
{
"denom": "coin3",
"amount": "1000000000000000000"
},
{
"denom": "coin4",
"amount": "1000000000000000000"
},
{
"denom": "hcoin",
"amount": "100000000000000000000000000"
}
],
"public_key": null,
"account_number": 0,
"sequence": 0,
"code_hash": "",
"ethAddress": "0xf60a4716edabdc1479c9b2562989a9ca106063da"
}
}
]
},
"punishment": {},
"distribution": {
"params": {
"community_tax": "0.020000000000000000",
"base_proposer_reward": "0.010000000000000000",
"bonus_proposer_reward": "0.040000000000000000",
"withdraw_addr_enabled": true
},
"fee_pool": {
"community_pool": []
},
"delegator_withdraw_infos": [],
"previous_proposer": "",
"outstanding_rewards": [],
"validator_accumulated_commissions": [],
"validator_historical_rewards": [],
"validator_current_rewards": [],
"delegator_starting_infos": [],
"validator_slash_events": []
},
"iam": {},
"genutil": {
"gentxs": [
{
"type": "cosmos-sdk/StdTx",
"value": {
"msg": [
{
"type": "cosmos-sdk/MsgCreateValidator",
"value": {
"description": {
"moniker": "localtestnet",
"identity": "",
"website": "",
"security_contact": "",
"details": ""
},
"commission": {
"rate": "0.100000000000000000",
"max_rate": "0.200000000000000000",
"max_change_rate": "0.010000000000000000"
},
"min_self_delegation": "1",
"delegator_address": "hashrs17c9yw9hd40wpg7wfkftznzdfeggxqc762ueavn",
"validator_address": "hashrsvaloper17c9yw9hd40wpg7wfkftznzdfeggxqc76xf2ukt",
"pubkey": "hashrsvalconspub1mznpzapq8f8sarrjv82ukreyr8xftzt7he6syf5z65v20enxd4gej6kll2tqn0ppyx",
"value": {
"denom": "hcoin",
"amount": "1000000"
}
}
}
],
"fee": {
"amount": [],
"gas": "200000"
},
"signatures": [
{
"pub_key": {
"type": "crypto/PubKeySecp256k1",
"value": "BGERmzsmgUwOz5FJcEla5xb55l2tqO0kHdryfBSOSoE5J7eUICRnyBV7N9uGEpdN2NKDtw1lfRs40McbnFWA8vs="
},
"signature": "yICEDXYbBP8mJzij+OeUV3BsJdbcUaMa2wauAalfl7tvTNlg3iccHVS6b7bXlbChT+BCnuXdvwc2ZJ0pyjnFawA="
}
],
"memo": "[email protected]:26656"
}
}
]
},
"evm": {
"accounts": []
}
}
}
}
}
health - Query node health status
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result: Result object
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/health'reponse:
{
"jsonrpc": "2.0",
"id": 1,
"result": {}
}
net_info - Query node network status
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result:result
- listening: Whether the node is in the listening state
- listeners: Node monitoring address array
- n_peers: Number of peer nodes
- peers: Peer node array
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/net_info'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"listening": true,
"listeners": [
"Listener(@)"
],
"n_peers": "4",
"peers": [
{
"node_info": {
"protocol_version": {
"p2p": "0",
"block": "0",
"app": "0"
},
"id": "e20590ab7c8e4abb202e800a81d93c41c608cc9b",
"listen_addr": "tcp://0.0.0.0:26656",
"network": "12069001",
"version": "0.0.3",
"channels": "4020213000",
"moniker": "cmp-testnet",
"other": {
"tx_index": "on",
"rpc_address": "tcp://0.0.0.0"
}
},
"is_outbound": false,
"connection_status": {
"Duration": "1684414280936",
"SendMonitor": {
"Start": "2020-12-10T02:22:15.58Z",
"Bytes": "120258",
"Samples": "585",
"InstRate": "197",
"CurRate": "157",
"AvgRate": "71",
"PeakRate": "409",
"BytesRem": "0",
"Duration": "1684420000000",
"Idle": "1520000000",
"TimeRem": "0",
"Progress": 0,
"Active": true
},
"RecvMonitor": {
"Start": "2020-12-10T02:22:15.58Z",
"Bytes": "131788",
"Samples": "576",
"InstRate": "0",
"CurRate": "5",
"AvgRate": "78",
"PeakRate": "70100",
"BytesRem": "0",
"Duration": "1684420000000",
"Idle": "3960000000",
"TimeRem": "0",
"Progress": 0,
"Active": true
},
"Channels": [
{
"ID": 48,
"SendQueueCapacity": "1",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "0"
},
{
"ID": 32,
"SendQueueCapacity": "100",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "661"
},
{
"ID": 33,
"SendQueueCapacity": "100",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "0"
},
{
"ID": 64,
"SendQueueCapacity": "1000",
"SendQueueSize": "0",
"Priority": "10",
"RecentlySent": "0"
},
{
"ID": 0,
"SendQueueCapacity": "10",
"SendQueueSize": "0",
"Priority": "1",
"RecentlySent": "1"
}
]
},
"remote_ip": "18.166.131.97"
},
{
"node_info": {
"protocol_version": {
"p2p": "0",
"block": "0",
"app": "0"
},
"id": "3d1de247b1c96e62e607ca4d713fa2da8e7381ec",
"listen_addr": "tcp://0.0.0.0:26656",
"network": "12069001",
"version": "0.0.3",
"channels": "4020213000",
"moniker": "cmp-testnet",
"other": {
"tx_index": "on",
"rpc_address": "tcp://0.0.0.0"
}
},
"is_outbound": false,
"connection_status": {
"Duration": "1154122363854",
"SendMonitor": {
"Start": "2020-12-10T02:31:05.88Z",
"Bytes": "91292",
"Samples": "411",
"InstRate": "197",
"CurRate": "157",
"AvgRate": "79",
"PeakRate": "2875",
"BytesRem": "0",
"Duration": "1154120000000",
"Idle": "1520000000",
"TimeRem": "0",
"Progress": 0,
"Active": true
},
"RecvMonitor": {
"Start": "2020-12-10T02:31:05.88Z",
"Bytes": "90423",
"Samples": "420",
"InstRate": "0",
"CurRate": "53",
"AvgRate": "78",
"PeakRate": "3450",
"BytesRem": "0",
"Duration": "1154120000000",
"Idle": "400000000",
"TimeRem": "0",
"Progress": 0,
"Active": true
},
"Channels": [
{
"ID": 48,
"SendQueueCapacity": "1",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "0"
},
{
"ID": 32,
"SendQueueCapacity": "100",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "661"
},
{
"ID": 33,
"SendQueueCapacity": "100",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "0"
},
{
"ID": 64,
"SendQueueCapacity": "1000",
"SendQueueSize": "0",
"Priority": "10",
"RecentlySent": "0"
},
{
"ID": 0,
"SendQueueCapacity": "10",
"SendQueueSize": "0",
"Priority": "1",
"RecentlySent": "56"
}
]
},
"remote_ip": "18.162.72.189"
},
{
"node_info": {
"protocol_version": {
"p2p": "0",
"block": "0",
"app": "0"
},
"id": "f909b49af1cfdfe52c959611306dd0f556fc39e1",
"listen_addr": "tcp://0.0.0.0:26656",
"network": "12069001",
"version": "0.0.3",
"channels": "4020213000",
"moniker": "cmp-testnet",
"other": {
"tx_index": "on",
"rpc_address": "tcp://0.0.0.0"
}
},
"is_outbound": false,
"connection_status": {
"Duration": "1006953903886",
"SendMonitor": {
"Start": "2020-12-10T02:33:33.04Z",
"Bytes": "81034",
"Samples": "387",
"InstRate": "197",
"CurRate": "170",
"AvgRate": "80",
"PeakRate": "1741",
"BytesRem": "0",
"Duration": "1006960000000",
"Idle": "1520000000",
"TimeRem": "0",
"Progress": 0,
"Active": true
},
"RecvMonitor": {
"Start": "2020-12-10T02:33:33.04Z",
"Bytes": "3332",
"Samples": "135",
"InstRate": "0",
"CurRate": "0",
"AvgRate": "3",
"PeakRate": "239",
"BytesRem": "0",
"Duration": "1006960000000",
"Idle": "46740000000",
"TimeRem": "0",
"Progress": 0,
"Active": true
},
"Channels": [
{
"ID": 48,
"SendQueueCapacity": "1",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "0"
},
{
"ID": 32,
"SendQueueCapacity": "100",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "661"
},
{
"ID": 33,
"SendQueueCapacity": "100",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "0"
},
{
"ID": 64,
"SendQueueCapacity": "1000",
"SendQueueSize": "0",
"Priority": "10",
"RecentlySent": "0"
},
{
"ID": 0,
"SendQueueCapacity": "10",
"SendQueueSize": "0",
"Priority": "1",
"RecentlySent": "0"
}
]
},
"remote_ip": "18.135.71.175"
},
{
"node_info": {
"protocol_version": {
"p2p": "0",
"block": "0",
"app": "0"
},
"id": "e942087a716d00f403f068b4358a9a507eacec59",
"listen_addr": "tcp://0.0.0.0:26656",
"network": "12069001",
"version": "0.0.3",
"channels": "4020213000",
"moniker": "cmp-testnet",
"other": {
"tx_index": "on",
"rpc_address": "tcp://0.0.0.0"
}
},
"is_outbound": false,
"connection_status": {
"Duration": "896148335229",
"SendMonitor": {
"Start": "2020-12-10T02:35:23.86Z",
"Bytes": "422792694",
"Samples": "2222",
"InstRate": "197",
"CurRate": "170",
"AvgRate": "471793",
"PeakRate": "5213250",
"BytesRem": "0",
"Duration": "896140000000",
"Idle": "1520000000",
"TimeRem": "0",
"Progress": 0,
"Active": true
},
"RecvMonitor": {
"Start": "2020-12-10T02:35:23.86Z",
"Bytes": "282348",
"Samples": "2120",
"InstRate": "0",
"CurRate": "62",
"AvgRate": "315",
"PeakRate": "4710",
"BytesRem": "0",
"Duration": "896140000000",
"Idle": "200000000",
"TimeRem": "0",
"Progress": 0,
"Active": true
},
"Channels": [
{
"ID": 48,
"SendQueueCapacity": "1",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "0"
},
{
"ID": 32,
"SendQueueCapacity": "100",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "661"
},
{
"ID": 33,
"SendQueueCapacity": "100",
"SendQueueSize": "0",
"Priority": "5",
"RecentlySent": "0"
},
{
"ID": 64,
"SendQueueCapacity": "1000",
"SendQueueSize": "0",
"Priority": "10",
"RecentlySent": "0"
},
{
"ID": 0,
"SendQueueCapacity": "10",
"SendQueueSize": "0",
"Priority": "1",
"RecentlySent": "17"
}
]
},
"remote_ip": "18.162.204.60"
}
]
}
}
num_unconfirmed_txs - Check unconfirmed transactions
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request -result:result
- n_txs: Number of unconfirmed transactions
- txs: Unconfirmed transaction array
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/num_unconfirmed_txs'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"n_txs": "0",
"txs": null
}
}
status - Query chain status
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result:
- node_info: Node information
- sync_info: Synchronization information
- validator_info: Verify node information
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/status'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"node_info": {
"protocol_version": {
"p2p": "0",
"block": "0",
"app": "0"
},
"id": "bd8034e832a2afe6ab171b593de1fcccaab679f0",
"listen_addr": "tcp://0.0.0.0:26656",
"network": "12069001",
"version": "0.0.3",
"channels": "4020213000",
"moniker": "cmp-testnet",
"other": {
"tx_index": "on",
"rpc_address": "tcp://0.0.0.0"
}
},
"sync_info": {
"latest_block_hash": "733C0244D2332C1AFA876ACFBE9266785AEDDB975D36C6D0CA24E8A19073C14B",
"latest_app_hash": "9160F38A3A9C3FF2738F72BBA4D5EEBF09FA092417B9CDFAD537FF01D131AB54",
"latest_block_height": "22451",
"catching_up": false
},
"validator_info": {
"address": "D77697AC1BE24338F668774C94CDD86C18956820",
"pub_key": {
"type": "hashrs/PubKeyEd25519",
"value": "0sghWEEnK8JyaHWlRJmSm4URfiA+lDL7C1cGle4lBNI="
},
"voting_power": "5"
}
}
}
tx - Get specified transaction
parameter
hash - Transaction hash, byte array
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result: Result Object
- hash: Hash
- height: Block height
- index: index
- tx_result: The result of the transaction code: 0 data: "" log: Log output info: information gasWanted: The amount of gas that needs to be consumed gasUsed: Gas used events: Event set codespace: "" tx:
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/tx? response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"hash": "733F9AB3683B63CCD0EC0D6F990CFBEA33C8BC414837BFECF462085122BB84E7",
"height": "47456",
"index": 0,
"tx_result": {
"code": 0,
"data": "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA",
"log": "[{\"msg_index\":0,\"log\":\"\",\"events\":[{\"type\":\"message\",\"attributes\":[{\"key\":\"action\",\"value\":\"ethereum\"}]}]}]",
"info": "",
"gasWanted": "65536",
"gasUsed": "0",
"events": [
{
"type": "message",
"attributes": [
{
"key": "YWN0aW9u",
"value": "ZXRoZXJldW0="
}
]
}
],
"codespace": ""
},
"tx": "5AE/0QlyCt0B63opiAgFEgoyNDQxNDA2MjUwGICABCIUX54v9b/ME1u+pqqVh66IVk01wbQqCjg1ODk5MzQ1OTI6BTE3ODExQk03MjE4MzkxNzMyNTc2ODE2ODAyNDk5MjAxMTY1NDc4ODQwOTE2NDc0MjczNjQyNDM2MzMyOTg5NDQwMzE0MTQ0MTczMDA1MzQyMjA2N0pNMTM3OTQ4OTUxNzE3MTUyODU3NzkzMTgzMzU5Nzg1MTUwMDk4NjUwOTIwOTA1OTQ0NDU2MjEwNDUxMjAzODc0NDk4MDE3MjI3Mjc1NDM="
}
}
unconfirmed_txs - Get unconfirmed transactions
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result: Result object n_txs: Number of unconfirmed transactions txs: Unconfirmed transaction array
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/unconfirmed_txs'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"n_txs": "0",
"txs": []
}
}
validators - Return to the verification node set
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result: Result object
- block_height: Block height
- validators: Verifier
- address: Verifier address
- pub_key: Verifier public key type: Signature algorithm value: public key
- voting_power: Voting rights
- proposer_priority: Applicant's priority
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/validators'response:
{
"jsonrpc": "2.0",
"id": -1,
"result": {
"block_height": "22452",
"validators": [
{
"address": "3013A65BB0718E92CD3173A34DAA157B29AB61D6",
"pub_key": {
"type": "hashrs/PubKeyEd25519",
"value": "2420Bfs/Vr8gcT4W8pv+hUwzweVPiKz5tcSRSNKa9ws="
},
"voting_power": "5",
"proposer_priority": "-20"
},
{
"address": "36AB19C745CF40EE79EE3B291A1F2B0DF7E4E83D",
"pub_key": {
"type": "hashrs/PubKeyEd25519",
"value": "/IJcjW1FGbbIQMC8oxx2DmGswQF+FZe4l5ePfpyjeHU="
},
"voting_power": "5",
"proposer_priority": "5"
},
{
"address": "BB7A5FC01E9656428630C1A1BDC44C8BC562BBEE",
"pub_key": {
"type": "hashrs/PubKeyEd25519",
"value": "UQUsWmuhr6u2lMfhK6QIjWtKFQHqcFFcVxwJrvt1/FA="
},
"voting_power": "5",
"proposer_priority": "5"
},
{
"address": "BCFE0B4F60A86B620C99725E0348703C9982E63A",
"pub_key": {
"type": "hashrs/PubKeyEd25519",
"value": "WGT0HoJB0tKYe/jc5YiB1af0np5+RRL1VgegxevdmUg="
},
"voting_power": "5",
"proposer_priority": "5"
},
{
"address": "D77697AC1BE24338F668774C94CDD86C18956820",
"pub_key": {
"type": "hashrs/PubKeyEd25519",
"value": "0sghWEEnK8JyaHWlRJmSm4URfiA+lDL7C1cGle4lBNI="
},
"voting_power": "5",
"proposer_priority": "5"
}
]
}
}
node_info - Query node data
parameter
no
return value
Return a JSON object, the structure is as follows:
- jsonrpc:JSONRPC version, fixed as "2.0"
- id:ID number of API request
- result: Result object
- node_info:
- protocol_version: Protocol version number p2p: p2p protocol version number block: Protocol version number of block app: Protocol version number of app
- id: Node id
- listen_addr: TCP listening address and port
- network: Network number
- version: Node version
- channels: Channel data
- moniker: Monitor the network
- other: tx_index: on is to open tx_index, off is to close rpc_address: rpc's IP and listening port
- application_version: App version name: Application Name server_name: name of server client_name: Client name version: version number commit: Submission number go: Go version and operating platform
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/node_info'response:
{
"node_info": {
"protocol_version": {
"p2p": "0",
"block": "0",
"app": "0"
},
"id": "a49ddadcbb379ddb81daf94708e3f4271ccbe715",
"listen_addr": "tcp://0.0.0.0:26656",
"network": "8888",
"version": "0.0.1",
"channels": "4020213000",
"moniker": "localtestnet",
"other": {
"tx_index": "on",
"rpc_address": "tcp://127.0.0.1"
}
},
"application_version": {
"name": "hashrs",
"server_name": "hashrsd",
"client_name": "hashrscli",
"version": "v0.0.2",
"commit": "c1c1b89",
"go": "go version go1.15.4 linux/amd64"
}
}
syncing - Check syncing status
parameter
no
return value
Return a JSON object, the structure is as follows:
- syncing: Synchronization is true, asynchronous is false
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/syncing'response:
{
"syncing": false
}
blocks/latest - Query the highest block information
parameter
no
return value
Return a JSON object, the structure is as follows:
- block_hash: Block hash
- block: Block information
- header: Block header
- version: Block version
- block: The version number of the block
- app: app version number
- chain_id: ID number of the chain
- height: Block height
- round_received: Receive round
- last_block_id: Previous block
- hash: Block hash
- timestamp: time
- validators_hash: Validator hash
- next_validators_hash: Next validator hash
- consensus_hash: Consensus hash
- last_results_hash: The result of the previous hash
- frame_hash: Hash in consensus state
- txs_hash: txs hash
- app_hash: app hash
- receipts_hash: Receiver's hash
- txs: Transaction set
- receipts:Recipient
- validator: Verifier
- event_cnt: number of events
- tx_cnt: tx number
- signatures: Signature information
- validator: Verifier
- sig: Signature information
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/blocks/latest'response:
{
"block_hash": "A05F9AEF6DD73F8B8DC750B2D2CCD10DD82621C9AF4A740A3E7D5E0B658A40C1",
"block": {
"header": {
"version": {
"block": "0",
"app": "0"
},
"chain_id": "8888",
"height": "1348",
"round_received": "1348",
"last_block_id": {
"hash": "F6C03249CE929EFB423F693AABD4FCE28B61BC362595FB7B47F844F9D6FF0DDF"
},
"timestamp": "2020-12-08T03:55:31.365856Z",
"validators_hash": "CA2A8986346FE3916C7990AEF0D5EF17D71B05CB6EACD99CA04D181E27B53B34",
"next_validators_hash": "8B3F76A7073DE568B8A29D5BE6651E0BDFC353DBFE45D6004221E4678CA23842",
"consensus_hash": "FE28D47CACD2C1933202E7921AA39830FE1FF73553AF679104FA60D921D5ABC1",
"last_results_hash": "",
"frame_hash": "FF413EE1B049B092378CE89BDE4CA24FD0E336AC5A62510CAAD89D69758853FF",
"txs_hash": "",
"app_hash": "C361A268A15F4EB4181DD3C6D65950F5A32DE14B580569E3AD13218DA8D3B443",
"receipts_hash": "AD59A91DC7A762D4D7567AFC504FF69842AB4CF33ABAB4157ACED758A43A2A7C"
},
"txs": null,
"receipts": [
{
"validator": "D8A61174203A4F0E8C7261D5CB0F2419CC95897EBE75022682D518A7E6666D51996ADFFA96",
"event_cnt": "1",
"tx_cnt": "0"
}
],
"signatures": [
{
"validator": "D8A61174203A4F0E8C7261D5CB0F2419CC95897EBE75022682D518A7E6666D51996ADFFA96",
"sig": "300E63583D8379ED348B61922B7FC041B5BE05D33FCDC65E169009040C362EEF3BA3BA0B4C730B9A01417EE6C746D7417B1A842C3EB3831D10F94AA8FD876D05"
}
]
}
}
blocks - Query specified block height information
parameter
height - The height of the block to be queried, int64, optional, default value: 0, which means the latest block
return value
Return a JSON object, the structure is as follows:
- block_hash: Block hash
- block: Block information
- header: Block header
- version: Block version
- block: The version number of the block
- app: app version number
- chain_id: ID number of the chain
- height: Block height
- round_received: Receive round
- last_block_id: Previous block
- hash: Block hash
- timestamp: time
- validators_hash: Validator hash
- next_validators_hash: Next validator hash
- consensus_hash: Consensus hash
- last_results_hash: The result of the previous hash
- frame_hash: Hash in consensus state
- txs_hash: txs hash
- app_hash: app hash
- receipts_hash: Receiver's hash
- txs: Transaction set
- receipts:Recipient
- validator: Verifier
- event_cnt: number of events
- tx_cnt: tx number
- signatures: Signature information
- validator: Verifier
- sig: Signature information
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/blocks/535'response:
{
"block_hash": "434924D5913FDD3128EBB5DC06C734362DA5732013A1B4FEAAED006A59C4D448",
"block": {
"header": {
"version": {
"block": "0",
"app": "0"
},
"chain_id": "8888",
"height": "535",
"round_received": "535",
"last_block_id": {
"hash": "108E63172F269B949F24CE0B2F0049C1FF8C498E6C892D3AF2B9F373CC29ECD8"
},
"timestamp": "2020-12-08T03:41:44.172665Z",
"validators_hash": "CA2A8986346FE3916C7990AEF0D5EF17D71B05CB6EACD99CA04D181E27B53B34",
"next_validators_hash": "8B3F76A7073DE568B8A29D5BE6651E0BDFC353DBFE45D6004221E4678CA23842",
"consensus_hash": "FE28D47CACD2C1933202E7921AA39830FE1FF73553AF679104FA60D921D5ABC1",
"last_results_hash": "",
"frame_hash": "259D3F3931FD02402114332FA9C29E6CA6D6AE44C24ABB4ADD0361220C6C2B6E",
"txs_hash": "CE3231E349A6ED970B2A7FFF17A04AEB73451CD1364D3E114511FCF4CAD734B8",
"app_hash": "3237ACB2EFF9B6313F04269BB1FEABB22C9F807BEF91E66B5F1D1D137BBD5747",
"receipts_hash": "7FC6BA370EEAC4B56679CED85F1939FE9B5493EA563E0B183A727A32481E4CC8"
},
"txs": [
"gAY/0QlyCvkF63opiAgBEgoyNDQxNDA2MjUwGICAQCoBMDK4BGBgYEBSNBVhAA9XYACA/VtbYQTSYACBkFVQYRYuYAFgADNz//////////////////////////8Wc///////////////////////////FoFSYCABkIFSYCABYAAggZBVUFtbYQHIgGEAcGAAOWAA8wBgYGBAUmAANXwBAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAJAEY/////8WgGNVVRZpFGEAVFeAY4U7LSkUYQB9V4BjvN/g1RRhAKBXW2AAgP1bNBVhAF9XYACA/VthAGdhAS9WW2BAUYCCgVJgIAGRUFBgQFGAkQOQ81s0FWEAiFdgAID9W2EAnmAEgIA1kGAgAZCRkFBQYQE5VlsAWzQVYQCrV2AAgP1bYQCzYQFEVltgQFGAgGAgAYKBA4JSg4GBUYFSYCABkVCAUZBgIAGQgIODYABbg4EQFWEA9FeAggFRgYQBUltgIIEBkFBhANhWW1BQUFCQUJCBAZBgHxaAFWEBIVeAggOAUWABg2AgA2EBAAoDGRaBUmAgAZFQW1CSUFBQYEBRgJEDkPNbYACAVJBQW5BWW4BgAIGQVVBbUFZbYQFMYQGIVltgQIBRkIEBYEBSgGAFgVJgIAF/SGVsbG8AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACBUlCQUFuQVltgIGBAUZCBAWBAUoBgAIFSUJBWAKFlYnp6cjBYILEBr3bZ2yWXQokuGcsi9kNQjby57UpfCBjwGchMYrYBACk6BTE3ODExQk05MjU2MTgxMTM0NDQ4NTg2NTMwMDMwOTUyNjEyNTQxOTYwOTAyNjI3MzI3NjU1NjU0MzI1MDk2NjAzNzkyOTAwMTcwMjI2OTk3MTU1MkpNMTExMDk5NDk5NzAyMjE4MjU3ODc4NzI2NDIyNDYzMzA2ODUwMTAxMjYyNTgwNzcyMzI5MTQ1NjAzOTY4MjA2MjkwMDk0MDgwMjAwNTU="
],
"receipts": [
{
"validator": "D8A61174203A4F0E8C7261D5CB0F2419CC95897EBE75022682D518A7E6666D51996ADFFA96",
"event_cnt": "1",
"tx_cnt": "1"
}
],
"signatures": [
{
"validator": "D8A61174203A4F0E8C7261D5CB0F2419CC95897EBE75022682D518A7E6666D51996ADFFA96",
"sig": "2655B8593D7B06F674D8BA1A3CA822EE46F55A66FEF1C36F64EF3603F700495B3EF9BEBC7D7613DD40F1AA86B395CD83432A88691D8275964FEEA5C3CC93450B"
}
]
}
}
validatorsets/latest - Query the verifier information of the highest block
parameter
no
return value
Return a JSON object, the structure is as follows:
- height: Block height
- result: result
- block_height: "1732",
- validators: Verifier information
- address: Verifier address
- pub_key: Verifier public key
- proposer_priority: Applicant's priority
- voting_power: Voting rights
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/validatorsets/latest'response:
{
"height": "0",
"result": {
"block_height": "1732",
"validators": [
{
"address": "hashrsvalcons1khfvk89sk94mgugwkv3v6yjv6m3l2k9mca4w5e",
"pub_key": "hashrsvalconspub1mznpzapq8f8sarrjv82ukreyr8xftzt7he6syf5z65v20enxd4gej6kll2tqn0ppyx",
"proposer_priority": "0",
"voting_power": "1"
}
]
}
}
validatorsets - Query the verifier information of the specified block height
parameter
height - The height of the block to be queried, int64, optional, default value: 0, which means the latest block
return value
Return a JSON object, the structure is as follows:
- height: Block height
- result: result
- block_height: "1732",
- validators: Verifier information
- address: Verifier address
- pub_key: Verifier public key
- proposer_priority: Applicant's priority
- voting_power: Voting rights
Sample code
request:
curl -X GET 'https://rpc.block.caduceus.global/validatorsets-height/535'response:
{
"height": "0",
"result": {
"block_height": "535",
"validators": [
{
"address": "hashrsvalcons1khfvk89sk94mgugwkv3v6yjv6m3l2k9mca4w5e",
"pub_key": "hashrsvalconspub1mznpzapq8f8sarrjv82ukreyr8xftzt7he6syf5z65v20enxd4gej6kll2tqn0ppyx",
"proposer_priority": "0",
"voting_power": "1"
}
]
}
}